/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
// r_vars.c: global refresh variables

// >>> FIX: For Nintendo Wii using devkitPPC / libogc
// Include only for the software renderer builds (part 1):
#if !defined(GXQUAKE) && !defined(GLQUAKE)
// <<< FIX

#if	!id386

#include	"quakedef.h"

// all global and static refresh variables are collected in a contiguous block
// to avoid cache conflicts.

//-------------------------------------------------------
// global refresh variables
//-------------------------------------------------------

// FIXME: make into one big structure, like cl or sv
// FIXME: do separately for refresh engine and driver

float	d_sdivzstepu, d_tdivzstepu, d_zistepu;
float	d_sdivzstepv, d_tdivzstepv, d_zistepv;
float	d_sdivzorigin, d_tdivzorigin, d_ziorigin;
// >>> FIX: For Nintendo Wii using devkitPPC / libogc
// New fixed16_t versions of the above:
fixed16_t d_sdivzstepu16, d_tdivzstepu16, d_zistepu16;
fixed16_t d_sdivzstepv16, d_tdivzstepv16, d_zistepv16;
fixed16_t d_sdivzorigin16, d_tdivzorigin16, d_ziorigin16;
// <<< FIX

fixed16_t	sadjust, tadjust, bbextents, bbextentt;

pixel_t			*cacheblock;
int				cachewidth;
pixel_t			*d_viewbuffer;
short			*d_pzbuffer;
unsigned int	d_zrowbytes;
unsigned int	d_zwidth;

#endif	// !id386

// >>> FIX: For Nintendo Wii using devkitPPC / libogc
// Include only for the software renderer builds (part 2):
#endif
// <<< FIX
